# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    upsync_version = ".".join(control.get_software_version().split(".")[:3])

    folder = "upsync-%s" % (upsync_version)
    binary = "%s.zip" % (upsync_version)
    url = "https://codeload.github.com/tranquilit/update-server-server-sync/zip/c04ca86dfcf165049835779d9d09b0557d6177c0"

    print("Download URL is: %s" % url)
    wget(url, binary, proxies=proxies)

    unzip(binary, folder)
    files = glob.glob("**/*.csproj", recursive=True)

    for file in files:
        content = ''
        f = open(file, 'r')
        tmp = f.read()
        while tmp != '':
            content = content + tmp
            tmp = f.read()
        f.close()
        pos = content.find('net6.0')
        pos2 = pos + len('net6.0')
        l_content = list(content)
        l_content[pos:pos2] = list('net9.0')
        content = "".join(l_content)
        f = open(file, 'w')
        f.write(content)
        f.close()

    # build_path = makepath(folder, 'update-server-server-sync-%s' % upsync_version, 'src', 'tools', 'upsync', 'upysync.csproj')
    build_path = glob.glob("**/upsync.csproj", recursive=True)[0]
    dotnet_path = makepath(programfiles(), 'dotnet', 'dotnet.exe')
    run('"%s" publish -p:PublishSingleFile=true --self-contained -c Release %s' % (dotnet_path, build_path))
    output_path = glob.glob("**/publish/upsync.exe", recursive=True)[0]
    # output_path = makepath(folder, 'update-server-server-sync-%s' % upsync_version, 'out', 'upsync', 'Release', 'net9.0', 'upsync.exe')
    shutil.move(output_path, 'upsync.exe')
    remove_tree(folder)
